//         
//          
//         
//           
//     
#include <\\MyClass\ClassCorelation.mqh>
#include <\\MyClass\ClassLinearRegression.mqh>
#include <Trade\Trade.mqh>
#include <Trade\OrderInfo.mqh>
#include <Trade\PositionInfo.mqh>
#include <Trade\AccountInfo.mqh>
#include <Trade\SymbolInfo.mqh>
//--- input parameters
input int      WindFast=2;//   2-10  1
input int      WindSlow=2;//   2-100  1
input double   CompFast=0.2;//   -1 1  0.05
input double   CompSlow=0.2;//   -1 1  0.05
input string   Instrum1="EURUSD";// 
input string   Instrum2="GBPUSD";// 
//=============================================================================
int hFastCorrel;//    
int hSlowCorrel;
double   openinstr1[],openinstr2[];//    
/*MqlTradeRequest requestmy;// 
MqlTradeResult  resultmy;//  */
MqlRates ratesinstr1[], ratesinstr2[];//  
Correlation correl ;
CLinReg linreg ;
CTrade   trade;// 
COrderInfo orderinfo;//  
CPositionInfo  posinfo;//  
CAccountInfo   accinfo;
CSymbolInfo    symbinfo;
int OnInit()
  {
   hFastCorrel=iCustom(Symbol(),Period(),"\\Sreader\Correl",WindFast,Instrum1,Instrum2) ;
   hSlowCorrel=iCustom(Symbol(),Period(),"\\Sreader\CorrelSlow",WindFast+WindSlow,Instrum1,Instrum2) ;
   if(hFastCorrel <0 || hSlowCorrel <0) Print("  =   ",GetLastError()) ;
   return(0);
  }
//=============================================================================
void OnDeinit(const int reason)
  {
  }
//=============================================================================
void OnTick()
  {
      if(!isNewBar(Instrum2)) return ;
      if( CopyRates(Instrum1,Period(),0,WindFast,ratesinstr1) <0 || CopyRates(Instrum2,Period(),0,WindFast,ratesinstr2)<0)
         {//  
            Print("    ");
            return ;            
         }
      ArraySetAsSeries(ratesinstr1,true); ArraySetAsSeries(ratesinstr2,true) ;
      double   fastcorr[],slowcorr[];//     
      if( CopyBuffer(hFastCorrel,0,0,1,fastcorr)<=0 || CopyBuffer(hSlowCorrel,0,0,1,slowcorr) <=0) 
      {
         Print("    ");
         return ;
      } 
      //Print("   = ",fastcorr[0],"      = ",slowcorr[0]);
      int i ;
      //double   openinstr1[],openinstr2[];//    
      ArrayResize(openinstr1,WindFast,0) ; ArrayResize(openinstr2,WindFast,0);
      for(i=0 ;i< WindFast; i++)
         {//      
            openinstr1[i]=ratesinstr1[i].open ;
            openinstr2[i]=ratesinstr2[i].open ;
         }
      if(posinfo.Select(Instrum1) || posinfo.Select(Instrum2))
         {//     a  
            if (fastcorr[0] > CompFast )//|| slowcorr[0] < CompSlow)
               {//         
                  Closepos(Instrum1) ;Closepos(Instrum2) ;
               }   
         }
//---------------------------------------------------------------------------------------------------
         //      
      if(fastcorr[0] < CompFast && !posinfo.Select(Instrum1) && !posinfo.Select(Instrum2) )
         {//         
            Openpos(Instrum1,Instrum2) ;
         }
  }
//============================================================================== 
bool isNewBar(string other_symbol)
  {//       
   static datetime last_bar_time=0;
   int cntsleep ;
   if(last_bar_time==0)
     {//---   ,     
      last_bar_time=(datetime)SeriesInfoInteger(_Symbol,Period(),SERIES_LASTBAR_DATE);
      return(false);
     }
   datetime curr_time=(datetime)SeriesInfoInteger(Symbol(),Period(),SERIES_LASTBAR_DATE);
   if(curr_time!=last_bar_time)
     {//       
      last_bar_time=curr_time;
      cntsleep=0 ;
      while(!(curr_time == (datetime)SeriesInfoInteger(other_symbol,Period(),SERIES_LASTBAR_DATE)))
         {//          
            Sleep(5000); 
            if(cntsleep >10) return(false) ;//  
            cntsleep++ ;
         }
      return(true) ;
     }
    return(false) ;
  }
//====================================================================================
void  Closepos(string instr)
   {//    
      trade.PositionClose(instr,-1) ;  
   }
//==============================================================================
double   Cumprofit(string instr1, string instr2)
   {//     
      double prof1,prof2 ;
      posinfo.Select(instr1) ;
      prof1=posinfo.Profit() ;
      posinfo.Select(instr2) ;
      prof2=posinfo.Profit() ;
      return(prof1+prof2) ;
   }
//==============================================================================
void  Openpos(string instr1,string instr2)
   {//    
      double   bid1,bid2,lot1,lot2 ;
      bid1=openinstr1[0];
      bid2=openinstr2[0];
      Print("   = ",bid1,"        = ",bid2) ;
      if( bid1 > bid2)
         {//        
            lot2=5.0 ;
            lot1=NormalizeDouble(bid1/bid2*lot2,2);
         }
        else {lot1=5.0 ; lot2=NormalizeDouble(bid2/bid1*lot1,2) ;}
      if(linreg.getUgol(openinstr1) >0 && linreg.getUgol(openinstr2) <0)
         {//      
            trade.Sell(lot1,instr1,0,0,0,NULL) ;trade.Buy(lot2,instr2,0,0,0,NULL) ;
            return ;
         }
      if(linreg.getUgol(openinstr1) < 0 && linreg.getUgol(openinstr2) >0)
         {//       
            trade.Buy(lot1,instr1,0,0,0,NULL) ; trade.Sell(lot2,instr2,0,0,0,NULL) ;
            return ;
         }
      return ;
   }
//==============================================================================